           (*-------------------------------------------*
            |                Csp-Prover                 |
            |                July 2004                  |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory Csp_DIV = Csp_semantics + Csp_STOP:

(*****************************************************************

         1. DIVsf : dom_SF
         2. 
         3. 
         4. 

 *****************************************************************)

(*********************************************************
               Lemmas (DIVsf in Dom_SF)
 *********************************************************)

(*******************************
        DIVsf in dom_SF 
 *******************************)

(* T2 *)

lemma DIVsf_in_T2 : "CT2 DIVsf"
apply (simp add: DIVsf_def CT2_def)
apply (intro allI impI)
apply (simp add: STOPt_in Abs_dom_T_inverse)
apply (simp add: emptyset_in_dom_F Abs_dom_F_inverse)

apply (simp add: STOPt_def)
apply (erule conjE)
apply (simp add: appt_to_app_or_sym)
apply (simp add: event_in_trace nil_in_trace Abs_trace_inverse)
done

(* F2 *)

lemma DIVsf_in_F2 : "CF2 DIVsf"
apply (simp add: DIVsf_def CF2_def)
apply (intro allI impI)
apply (simp add: emptyset_in_dom_F Abs_dom_F_inverse)
done

(* F3 *)

lemma DIVsf_in_F3 : "CF3 DIVsf"
apply (simp add: DIVsf_def CF3_def)
apply (intro allI impI)
apply (simp add: emptyset_in_dom_F Abs_dom_F_inverse)
done

(*** DIVf in dom_SF ***)

lemma DIVsf_in : "DIVsf: dom_SF"
apply (simp add: dom_SF_def)
apply (simp add: DIVsf_in_T2)
apply (simp add: DIVsf_in_F2)
apply (simp add: DIVsf_in_F3)
done

(*********************************************************
                  DIV trace eval
 *********************************************************)

lemma DIVt_eval: "ALL ev. [[DIV]]T ev = STOPt"
apply (intro allI)
apply (simp add: eval_T_def)
apply (simp add: DIVsf_def)
apply (simp add: STOPt_in Abs_dom_T_inverse)
done

(*********************************************************
                  DIV failure eval
 *********************************************************)

lemma DIVf_eval: "ALL ev. [[DIV]]F ev = {}"
apply (intro allI)
apply (simp add: eval_F_def)
apply (simp add: DIVsf_def)
apply (simp add: emptyset_in_dom_F Abs_dom_F_inverse)
done

end
