           (*-------------------------------------------*
            |                Csp-Prover                 |
            |               October 2004                |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory Csp_cont_fp = Csp_semantics:

(*****************************************************************

         1. [[<C>]]SF : continuous
         2.
         3. 
         4. 

 *****************************************************************)

(*  The following simplification rules are deleted in this theory file *)
(*  because they unexpectly rewrite UnionT and InterT.                 *)
(*                  Union (B ` A) = (UN x:A. B x)                      *)
(*                  Inter (B ` A) = (INT x:A. B x)                     *)

declare Union_image_eq [simp del]
declare Inter_image_eq [simp del]

(*** cont [[<C>]]TF ***)

lemma cont_fp_TF: "ALL C. cont [[<C>]]TF"
apply (rule allI)
apply (simp)
apply (rule cont_iffI)
apply (intro allI impI)
apply (elim conjE)
apply (erule prod_lub_decompoE)
apply (drule_tac x="C" in spec)
apply (simp add: directed_def)
apply (erule conjE)
apply (rotate_tac -1)
apply (erule rem_asmE)
apply (erule nonempty_exE)

apply (simp add: lub_to_lub_TF)
apply (insert lub_is_lub_SF)
apply (drule_tac x="{xp C |xp. xp : X}" in spec)
apply (drule_tac x="x C" in spec)
apply (simp)
apply (erule rem_asmE)

apply (simp add: lub_SF_def)
apply (insert lub_TF_in)
apply (drule_tac x="Rep_dom_SF ` {xp C |xp. xp : X}" in spec)
apply (drule mp)
apply (simp add: Rep_dom_SF)

apply (simp add: Abs_dom_SF_inverse)
apply (rotate_tac -1)
apply (erule rem_asmE)
apply (rotate_tac -1)
apply (erule rem_asmE)

apply (simp add: lub_TF_def)
apply (rule conjI)

(* T *)

apply (simp add: dom_T_Union_in_dom_T Abs_dom_T_inject)
apply (rule equalityI)

 (* <= *)

apply (rule subsetI)
apply (simp)
apply (elim conjE exE)
apply (rule_tac x="xp" in bexI)
apply (simp)
apply (simp)

 (* => *)

apply (rule subsetI)
apply (simp)
apply (elim conjE bexE)
apply (rule_tac x="xa C" in exI)
apply (simp)
apply (rule_tac x="xa" in exI)
apply (simp)

(* F *)

apply (simp add: dom_F_Union_in_dom_F Abs_dom_F_inject)
apply (rule equalityI)

 (* <= *)

apply (rule subsetI)
apply (simp)
apply (elim conjE exE)
apply (rule_tac x="xp" in bexI)
apply (simp)
apply (simp)

 (* => *)

apply (rule subsetI)
apply (simp)
apply (elim conjE bexE)
apply (rule_tac x="xa C" in exI)
apply (simp)
apply (rule_tac x="xa" in exI)
apply (simp)
done

(****************** to add them again ******************)

declare Union_image_eq [simp]
declare Inter_image_eq [simp]

end
