           (*-------------------------------------------*
            |                Csp-Prover                 |
            |                July 2004                  |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory Csp_map_Rename = Csp_Rename:

(*****************************************************************

         1. SF [[r]]sf : non-expanding
         2.
         3. 
         4. 

 *****************************************************************)

(*********************************************************
                    rest rest_Renamet
 *********************************************************)

(*** (<=) ***)

(* main *)

lemma rest_Renamet_sub :
  "ALL r S T n. S:dom_T & T:dom_T &
        (Abs_dom_T S) rest n <= (Abs_dom_T T) rest n
     --> Abs_dom_T (S [[r]]t) rest n <= 
         Abs_dom_T (T [[r]]t) rest n"

apply (intro allI impI)
apply (simp add: rest_T_def)
apply (simp add: subset_T_def)
apply (simp add: restTset_in Abs_dom_T_inverse)
apply (simp add: restTset_def)
apply (erule conjE)+
apply (simp add: Renamet_in Abs_dom_T_inverse)

apply (rule subsetI)
apply (simp add: Renamet_def)
apply (elim conjE bexE)

apply (erule subsetE)
apply (drule_tac x="s" in bspec)
apply (simp add: ren_length)

apply (rule_tac x="s" in bexI)
apply (simp_all)
done

(*** (=) ***)

lemma rest_Renamet :
  "ALL r S T n. S:dom_T & T:dom_T &
        (Abs_dom_T S) rest n = (Abs_dom_T T) rest n
     --> Abs_dom_T (S [[r]]t) rest n = 
         Abs_dom_T (T [[r]]t) rest n"
apply (intro allI impI)
apply (rule order_antisym)
apply (simp_all add: rest_Renamet_sub)
done

(*********************************************************
                    rest Renamef
 *********************************************************)

(*** (<=) ***)

lemma rest_Renamef_sub :
  "ALL r E F n. E:dom_F & F:dom_F &
        (Abs_dom_F E) rest n <= (Abs_dom_F F) rest n
     --> Abs_dom_F (E [[r]]f) rest n <= 
         Abs_dom_F (F [[r]]f) rest n"
apply (intro allI impI)
apply (simp add: rest_F_def)
apply (simp add: subset_F_def)
apply (simp add: restFset_in Abs_dom_F_inverse)
apply (simp add: restFset_def)
apply (erule conjE)+
apply (simp add: Renamef_in Abs_dom_F_inverse)

apply (rule subsetI)
apply (simp add: Renamef_def del: split_eta_SetCompr2)
apply (elim conjE exE)
apply (simp)

apply (rule_tac x="sa" in exI)
apply (simp)

apply (erule subsetE)
apply (drule_tac x="(sa, <invEv r> X)" in bspec)
apply (simp add: ren_length)

apply (erule disjE)
apply (simp, simp)
apply (elim conjE exE)

apply (simp)
apply (insert ren_decompo_from)
apply (drule_tac x="r" in spec)
apply (drule_tac x="s'" in spec)
apply (drule_tac x="[Tick]t" in spec)
apply (drule_tac x="sa" in spec)
apply (simp)
apply (elim conjE exE)

apply (rule_tac x="s1" in exI)
apply (simp)
apply (insert ren_from_tick)
apply (drule_tac x="r" in spec)
apply (drule_tac x="s2" in spec)
apply (simp)
apply (insert ren_from_notick)
apply (drule_tac x="r" in spec)
apply (drule_tac x="s'" in spec)
apply (drule_tac x="s1" in spec)
apply (simp)

apply (simp)
done

(*** (=) ***)

lemma rest_Renamef :
  "ALL r E F n. E:dom_F & F:dom_F &
        (Abs_dom_F E) rest n = (Abs_dom_F F) rest n
     --> Abs_dom_F (E [[r]]f) rest n = 
         Abs_dom_F (F [[r]]f) rest n"
apply (intro allI impI)
apply (rule order_antisym)
apply (simp_all add: rest_Renamef_sub)
done

(*********************************************************
                      dis Renamet
 *********************************************************)

lemma dis_Renamet:
  "ALL r S T.
       distance(Abs_dom_T (Rep_dom_T S [[r]]t), Abs_dom_T (Rep_dom_T T [[r]]t)) 
       <= distance(S, T)"
apply (intro allI impI)
apply (insert rest_to_dis_exists_pair)
apply (drule_tac x="(%x. x)" in spec)
apply (drule_tac x="{(S,T)}" in spec)
apply (drule_tac x="Abs_dom_T (Rep_dom_T S [[r]]t)" in spec)
apply (drule_tac x="Abs_dom_T (Rep_dom_T T [[r]]t)" in spec)
apply (insert rest_Renamet)
apply (drule_tac x="r" in spec)
apply (drule_tac x="Rep_dom_T S" in spec)
apply (drule_tac x="Rep_dom_T T" in spec)
apply (simp add: Rep_dom_T Rep_dom_T_inverse)
done

(*********************************************************
                      dis Renamef
 *********************************************************)

lemma dis_Renamef:
  "ALL r E F.
       distance(Abs_dom_F (Rep_dom_F E [[r]]f), Abs_dom_F (Rep_dom_F F [[r]]f)) 
       <= distance(E, F)"
apply (intro allI impI)
apply (insert rest_to_dis_exists_pair)
apply (drule_tac x="(%x. x)" in spec)
apply (drule_tac x="{(E,F)}" in spec)
apply (drule_tac x="Abs_dom_F (Rep_dom_F E [[r]]f)" in spec)
apply (drule_tac x="Abs_dom_F (Rep_dom_F F [[r]]f)" in spec)
apply (insert rest_Renamef)
apply (drule_tac x="r" in spec)
apply (drule_tac x="Rep_dom_F E" in spec)
apply (drule_tac x="Rep_dom_F F" in spec)
apply (simp add: Rep_dom_F Rep_dom_F_inverse)
done

(*********************************************************
                      dis Renamesf
 *********************************************************)

lemma dis_Renamesf:
  "ALL r SE TF.
       distance(SE [[r]]sf, TF [[r]]sf) <= distance(SE, TF)"
apply (intro allI impI)
apply (simp add: Renamesf_def)

      (* dom_T part *)

apply (insert dis_Renamet)
apply (drule_tac x="r" in spec)
apply (drule_tac x="fst SE" in spec)
apply (drule_tac x="fst TF" in spec)

      (* dom_F part *)

apply (insert dis_Renamef)
apply (drule_tac x="r" in spec)
apply (drule_tac x="snd SE" in spec)
apply (drule_tac x="snd TF" in spec)

  (* solve max *)

apply (case_tac "distance (fst SE, fst TF)
              <= distance (snd SE, snd TF)")
apply (simp add: pair_distance)
apply (simp add: max_x_y)
apply (simp add: pair_distance)
apply (simp add: max_y_x)
done

end
