           (*-------------------------------------------*
            |                Csp-Prover                 |
            |               October 2004                |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory Domain_SF_prod_cpo = Domain_SF_cpo + Domain_SF_prod + CPO_prod:

(*****************************************************************

         1. ('i,'a) dom_SF_prod is a CPO.
         2. 
         3. 
         4. 

 *****************************************************************)

(**************************************************************)
(*                                                            *)
(*  It has already proven that ('i,'a) dom_SF_prod is a CPO   *)
(*  because dom_SF is a CPO and "=>" preserves CPO.           *)
(*                                                            *)
(*  instance dom_SF :: (type) cpo_bot in Domain_SF_cpo.thy    *)
(*  instance fun :: (type,cpo_bot) cpo_bot in CPO_prod.thy    *)
(*                                                            *)
(**************************************************************)

(*----------------------------------------------------------*
 |                                                          |
 |         Fixed point induction for refinement             |
 |                                                          |
 *----------------------------------------------------------*)

(************************************************************
         admissibility lemma for refinement for cpo
 ************************************************************)

lemma Rev_SF_prod_adm: "ALL SEp. adm (Rev_SF_prod SEp)"
apply (intro allI)
apply (simp add: Rev_SF_prod_def)

apply (simp add: adm_def)
apply (auto)

apply (insert complete_cpo_lm)
apply (drule_tac x="X" in spec)
apply (auto)

apply (insert LUB_lub_imp)
apply (drule_tac x="X" in spec)
apply (drule_tac x="x" in spec)
apply (simp)

apply (simp add: is_lub_def)
apply (elim conjE)
apply (drule_tac x="SEp" in spec)
apply (simp add: is_ub_def)
done

(*** Bot ***)

lemma Rev_SF_prod_Bot: "ALL SEp. Rev_SF_prod SEp Bot"
apply (simp add: Rev_SF_prod_def bottom_bot)
done

(************************************************************
         Fixed Point Induction (CPO) for refinement
 ************************************************************)

theorem cpo_fixpoint_induction_rev:
  "ALL f (SEp::('i,'a) dom_SF_prod).
        cont f & f SEp <= SEp --> LFP f <= SEp"
apply (intro allI impI)
apply (insert cpo_fixpoint_induction_LFP)
apply (drule_tac x="(Rev_SF_prod SEp)" in spec)
apply (drule_tac x="f" in spec)
apply (drule mp)
apply (simp add: Rev_SF_prod_adm Rev_SF_prod_Bot)

      (* inductiveness *)
apply (simp add: inductivefun_def Rev_SF_prod_def)
apply (intro allI impI)
apply (insert cont_mono)
apply (drule_tac x="f" in spec)

apply (simp add: mono_def)
apply (elim conjE)
apply (drule_tac x="x" in spec)
apply (drule_tac x="SEp" in spec)
apply (simp)

      (* fixped point induction *)
apply (simp add: Rev_SF_prod_def)
done

(*** EX version ***)

theorem cpo_fixpoint_induction_rev_EX:
  "ALL f (SEp::('i,'a) dom_SF_prod) SFp.
        cont f & f SEp <= SEp & SFp isLFP f --> SFp <= SEp"
apply (intro allI impI)
apply (insert cpo_fixpoint_induction_rev)
apply (drule_tac x="f" in spec)
apply (drule_tac x="SEp" in spec)
apply (auto simp add: the_lfp)
done

end
