           (*-------------------------------------------*
            |  The Dining Mathematicians in Csp-Prover  |
            |               August 2004                 |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory DM06_hide = DM05_para:

(*****************************************************************

         1. expands hiding operators in Sys
         2.
         3. 
         4. 

 *****************************************************************)

(******************** Hiding ********************)

(*** Back0 VAR Back1 HIDE ***)

lemma Back0_VAR_Back1_HIDE: 
  "LET SysDef IN (Back0 -> <TH0> |[CH0]| <VAR n> |[CH1]| Back1 -> <TH1>)
                 -- (CH0 Un CH1)
   =F
   LET SysDef IN 
        Back0 -> ((<TH0> |[CH0]| <VAR n> |[CH1]| Back1 -> <TH1>)
                     -- (CH0 Un CH1))
        [+]
        Back1 -> ((Back0 -> <TH0> |[CH0]| <VAR n> |[CH1]| <TH1>)
                     -- (CH0 Un CH1))"
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
apply (tactic {* csp_step_tac 1 *})
apply (auto)
apply (tactic {* csp_simp_add_tac "fold_SYS_rules" 1 *})+
done

lemmas unfold_SYS_rules = unfold_SYS_rules  
                          csp_rule_rw[OF Back0_VAR_Back1_HIDE]
lemmas fold_SYS_rules   = fold_SYS_rules    
                          csp_rule_rev_rw[OF Back0_VAR_Back1_HIDE[simplified]]

(*** Eat0 VAR Back1 HIDE ***)

lemma Eat0_VAR_Back1_HIDE: 
  "EVEN n ==>
   LET SysDef IN (Eat0 -> <EAT0 n> |[CH0]| <VAR n> |[CH1]| Back1 -> <TH1>)
                 -- (CH0 Un CH1)
   =F
   LET SysDef IN 
        Eat0 -> ((<EAT0 n> |[CH0]| <VAR n> |[CH1]| Back1 -> <TH1>)
                 -- (CH0 Un CH1))
        [+]
        Back1 -> ((Eat0 -> <EAT0 n> |[CH0]| <VAR n> |[CH1]| <TH1>)
                 -- (CH0 Un CH1))"
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
apply (tactic {* csp_step_tac 1 *})
apply (auto)
apply (tactic {* csp_simp_add_tac "fold_SYS_rules" 1 *})+
done

lemmas unfold_SYS_rules = unfold_SYS_rules  
                          csp_rule_rw[OF Eat0_VAR_Back1_HIDE]
lemmas fold_SYS_rules   = fold_SYS_rules    
                          csp_rule_rev_rw[OF Eat0_VAR_Back1_HIDE[simplified]]

(*** Back0 VAR Eat1 HIDE ***)

lemma Back0_VAR_Eat1_HIDE: 
  "ODD n ==>
   LET SysDef IN (Back0 -> <TH0> |[CH0]| <VAR n> |[CH1]| Eat1 -> <EAT1 n>)
                 -- (CH0 Un CH1)
   =F
   LET SysDef IN 
        Eat1 -> ((Back0 -> <TH0> |[CH0]| <VAR n> |[CH1]| <EAT1 n>)
                 -- (CH0 Un CH1))
        [+]
        Back0 -> ((<TH0> |[CH0]| <VAR n> |[CH1]| Eat1 -> <EAT1 n>)
                 -- (CH0 Un CH1))"
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
apply (tactic {* csp_step_tac 1 *})
apply (auto)
apply (tactic {* csp_simp_add_tac "fold_SYS_rules" 1 *})+
done

lemmas unfold_SYS_rules = unfold_SYS_rules  
                          csp_rule_rw[OF Back0_VAR_Eat1_HIDE]
lemmas fold_SYS_rules   = fold_SYS_rules    
                          csp_rule_rev_rw[OF Back0_VAR_Eat1_HIDE[simplified]]

(*** EAT0 VAR Back1 HIDE ***)

lemma EAT0_VAR_Back1_HIDE: 
  "EVEN n ==>
   LET SysDef IN (<EAT0 n> |[CH0]| <VAR n> |[CH1]| Back1 -> <TH1>)
                 -- (CH0 Un CH1)
   =F
   LET SysDef IN 
        End0 -> ((WR0 (n div 2) -> <TH0> |[CH0]| <VAR n> |[CH1]| Back1 -> <TH1>)
                 -- (CH0 Un CH1))
        [+]
        Back1 -> ((<EAT0 n> |[CH0]| <VAR n> |[CH1]| <TH1>)
                 -- (CH0 Un CH1))"
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
apply (tactic {* csp_step_tac 1 *})
apply (auto)
apply (tactic {* csp_simp_add_tac "fold_SYS_rules" 1 *})+
done

lemmas unfold_SYS_rules = unfold_SYS_rules  
                          csp_rule_rw[OF EAT0_VAR_Back1_HIDE]
lemmas fold_SYS_rules   = fold_SYS_rules    
                          csp_rule_rev_rw[OF EAT0_VAR_Back1_HIDE[simplified]]

(*** Back0 VAR EAT1 HIDE ***)

lemma Back0_VAR_EAT1_HIDE: 
  "ODD n ==>
   LET SysDef IN (Back0 -> <TH0> |[CH0]| <VAR n> |[CH1]| <EAT1 n>)
                 -- (CH0 Un CH1)
   =F
   LET SysDef IN 
        End1 -> ((Back0 -> <TH0> |[CH0]| <VAR n> 
                                 |[CH1]| WR1 (3 * n + 1) -> <TH1>)
                  -- (CH0 Un CH1))
        [+]
        Back0 -> ((<TH0> |[CH0]| <VAR n> |[CH1]| <EAT1 n>)
                  -- (CH0 Un CH1))"
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
apply (tactic {* csp_step_tac 1 *})
apply (auto)
apply (tactic {* csp_simp_add_tac "fold_SYS_rules" 1 *})+
done

lemmas unfold_SYS_rules = unfold_SYS_rules  
                          csp_rule_rw[OF Back0_VAR_EAT1_HIDE]
lemmas fold_SYS_rules   = fold_SYS_rules    
                          csp_rule_rev_rw[OF Back0_VAR_EAT1_HIDE[simplified]]

end
