           (*-------------------------------------------*
            |  The Dining Mathematicians in Csp-Prover  |
            |               August 2004                 |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory DM09_Seq_def = DM08_hide:

(*****************************************************************

         1. defines Seq
         2.
         3. 
         4. 

 *****************************************************************)

(*********************************************************
                 process and specification 
 *********************************************************)

datatype SeqName = Seq_TH0_TH1     int
                 |  Seq_Eat0_TH1   int |  Seq_TH0_Eat1   int
                 |  Seq_Back0_TH1  int |  Seq_TH0_Back1  int
                 |  Seq_EAT0_TH1   int |  Seq_TH0_EAT1   int
                 |  Seq_WR0_TH1    int |  Seq_TH0_WR1    int
                 |  Seq_EAT0_Back1 int |  Seq_Back0_EAT1 int
                 |  Seq_WR0_Back1  int |  Seq_Back0_WR1  int

consts 
  SeqDef :: "(SeqName, Event) procDef"

(***********************************************************
          --- Guarded expression of SeqDef ---
 ***********************************************************)

primrec
 "SeqDef
   (Seq_TH0_TH1 n)
     = (IF EVEN n THEN (Eat0 -> <Seq_EAT0_TH1 n> [> 
                       (Eat0 -> <Seq_EAT0_Back1 n> [+] 
                        Back1 -> <Seq_Eat0_TH1 n>))
                  ELSE (Back0 -> <Seq_TH0_TH1 n> [>
                       (Eat1 -> <Seq_Back0_EAT1 n> [+] 
                        Back0 -> <Seq_TH0_Eat1 n>)))

       |~|
       (IF ODD  n THEN (Eat1 -> <Seq_TH0_EAT1 n> [> 
                       (Eat1 -> <Seq_Back0_EAT1 n> [+]
                        Back0 -> <Seq_TH0_Eat1 n>))
                  ELSE (Back1 -> <Seq_TH0_TH1 n> [>
                       (Eat0 -> <Seq_EAT0_Back1 n> [+] 
                        Back1 -> <Seq_Eat0_TH1 n>)))"

 "SeqDef
   (Seq_Eat0_TH1 n)
     = IF EVEN n 
       THEN (Eat0 -> <Seq_EAT0_TH1 n> [> 
            (Eat0 -> <Seq_EAT0_Back1 n> [+] 
             Back1 -> <Seq_Eat0_TH1 n>))
       ELSE undef -> DIV"

 "SeqDef
   (Seq_TH0_Eat1 n)
     = IF ODD n
       THEN (Eat1 -> <Seq_TH0_EAT1 n> [> 
            (Eat1 -> <Seq_Back0_EAT1 n> [+]
             Back0 -> <Seq_TH0_Eat1 n>))
       ELSE undef -> DIV"

 "SeqDef
   (Seq_Back0_TH1 n)
     = Back0 -> <Seq_TH0_TH1 n> [>
      (IF ODD n 
       THEN (Eat1 -> <Seq_Back0_EAT1 n> [+] 
             Back0 -> <Seq_TH0_Eat1 n>) 
       ELSE (Back0 -> <Seq_TH0_Back1 n> [+] 
             Back1 -> <Seq_Back0_TH1 n>))"

 "SeqDef
   (Seq_TH0_Back1 n)
     = Back1 -> <Seq_TH0_TH1 n> [>
      (IF EVEN n 
       THEN (Eat0 -> <Seq_EAT0_Back1 n> [+] 
             Back1 -> <Seq_Eat0_TH1 n>) 
       ELSE (Back0 -> <Seq_TH0_Back1 n> [+] 
             Back1 -> <Seq_Back0_TH1 n>))"

 "SeqDef
   (Seq_EAT0_TH1 n)
     = IF EVEN n
       THEN (End0 -> <Seq_WR0_TH1 n> [> 
            (End0 -> <Seq_WR0_Back1 n> [+] 
             Back1 -> <Seq_EAT0_TH1 n>))
       ELSE undef -> DIV"

 "SeqDef
   (Seq_TH0_EAT1 n)
     = IF ODD n 
       THEN (End1 -> <Seq_TH0_WR1 n> [> 
            (End1 -> <Seq_Back0_WR1 n> [+] 
             Back0 -> <Seq_TH0_EAT1 n>))
       ELSE undef -> DIV"

 "SeqDef
   (Seq_WR0_TH1 n)
     = IF EVEN n
       THEN ((IF EVEN (n div 2) 
              THEN (Eat0 -> <Seq_EAT0_TH1 (n div 2)> [> 
                   (Eat0 -> <Seq_EAT0_Back1 (n div 2)> [+] 
                    Back1 -> <Seq_Eat0_TH1 (n div 2)>))
              ELSE (Back0 -> <Seq_TH0_TH1 (n div 2)> [>
                   (Eat1 -> <Seq_Back0_EAT1 (n div 2)> [+] 
                    Back0 -> <Seq_TH0_Eat1 (n div 2)>)))
             |~|
             (IF ODD  (n div 2) 
              THEN (Eat1 -> <Seq_TH0_EAT1 (n div 2)> [> 
                   (Eat1 -> <Seq_Back0_EAT1 (n div 2)> [+]
                    Back0 -> <Seq_TH0_Eat1 (n div 2)>))
              ELSE (Back1 -> <Seq_TH0_TH1 (n div 2)> [>
                   (Eat0 -> <Seq_EAT0_Back1 (n div 2)> [+] 
                    Back1 -> <Seq_Eat0_TH1 (n div 2)>)))
              |~|
              (Back1 -> <Seq_WR0_TH1 n> [> 
              (Back1 -> <Seq_TH0_TH1 (n div 2)> [>
              (IF EVEN (n div 2) 
               THEN (Eat0 -> <Seq_EAT0_Back1 (n div 2)> [+] 
                     Back1 -> <Seq_Eat0_TH1 (n div 2)>) 
               ELSE (Back0 -> <Seq_TH0_Back1 (n div 2)> [+] 
                     Back1 -> <Seq_Back0_TH1 (n div 2)>)))))
       ELSE undef -> DIV"

 "SeqDef
   (Seq_TH0_WR1 n)
     = IF ODD n
       THEN ((Eat0 -> <Seq_EAT0_TH1 (3 * n + 1)> [> 
             (Eat0 -> <Seq_EAT0_Back1 (3 * n + 1)> [+] 
              Back1 -> <Seq_Eat0_TH1 (3 * n + 1)>))
              |~|
             (Back1 -> <Seq_TH0_TH1 (3 * n + 1)> [>
             (Eat0 -> <Seq_EAT0_Back1 (3 * n + 1)> [+] 
              Back1 -> <Seq_Eat0_TH1 (3 * n + 1)>))
              |~| 
             (Back0 -> <Seq_TH0_WR1 n> [> 
             (Back0 -> <Seq_TH0_TH1 (3 * n + 1)> [>
              (Back0 -> <Seq_TH0_Back1 (3 * n + 1)> [+] 
               Back1 -> <Seq_Back0_TH1 (3 * n + 1)>))))
       ELSE undef -> DIV"

 "SeqDef
   (Seq_EAT0_Back1 n)
     = IF EVEN n
       THEN (End0 -> <Seq_WR0_Back1 n> [+] 
             Back1 -> <Seq_EAT0_TH1 n>)
       ELSE undef -> DIV"

 "SeqDef
   (Seq_Back0_EAT1 n)
     = IF ODD n
       THEN (End1 -> <Seq_Back0_WR1 n> [+] 
             Back0 -> <Seq_TH0_EAT1 n>)
       ELSE undef -> DIV"

 "SeqDef
   (Seq_WR0_Back1 n)
     = IF EVEN n
       THEN (Back1 -> <Seq_WR0_TH1 n> [> 
            (Back1 -> <Seq_TH0_TH1 (n div 2)> [>
            (IF EVEN (n div 2) 
             THEN (Eat0 -> <Seq_EAT0_Back1 (n div 2)> [+] 
                   Back1 -> <Seq_Eat0_TH1 (n div 2)>) 
             ELSE (Back0 -> <Seq_TH0_Back1 (n div 2)> [+] 
                   Back1 -> <Seq_Back0_TH1 (n div 2)>))))
       ELSE undef -> DIV"

 "SeqDef
   (Seq_Back0_WR1 n)
     = IF ODD n
       THEN (Back0 -> <Seq_TH0_WR1 n> [> 
            (Back0 -> <Seq_TH0_TH1 (3 * n + 1)> [>
             (Back0 -> <Seq_TH0_Back1 (3 * n + 1)> [+] 
              Back1 -> <Seq_Back0_TH1 (3 * n + 1)>)))
       ELSE undef -> DIV"

(* note: ODD n  ==> EVEN (3 * n + 1)               *)
(* note: EVEN n ==> EVEN (n div 2) | ODD (n div 2) *)

consts
  Seq :: "int => (SeqName, Event) procRec"

defs
  Seq_def:
   "Seq == (%n.
     LET SeqDef IN <Seq_TH0_TH1 n>)"

(*********************************************************
               nohide and guarded lemmas
 *********************************************************)

lemma guardSeqDef[simp]: "!!C. guard ((SeqDef) C)"
apply (induct_tac C, simp_all)
done

lemma nohideSeqDef[simp]: "!!C. nohide ((SeqDef) C)"
apply (induct_tac C, simp_all)
done

(*********************************************************
              ALL n.  verify SEQ n =sf SYS n
 *********************************************************)

(*** relation between SEQdf and SYSdf ***)

consts 
  Seq_to_Sys :: "SeqName => (SysName, Event) proc"

primrec
 "Seq_to_Sys
   (Seq_TH0_TH1 n)
     = (<TH0> |[CH0]| <VAR n> |[CH1]| <TH1>) -- (CH0 Un CH1)"

 "Seq_to_Sys
   (Seq_Eat0_TH1 n)
     = IF EVEN n 
       THEN (Eat0 -> <EAT0 n> |[CH0]| <VAR n> |[CH1]| <TH1>) -- (CH0 Un CH1)
       ELSE undef -> DIV"

 "Seq_to_Sys
   (Seq_TH0_Eat1 n)
     = IF ODD n
       THEN (<TH0> |[CH0]| <VAR n> |[CH1]| Eat1 -> <EAT1 n>) -- (CH0 Un CH1)
       ELSE undef -> DIV"

 "Seq_to_Sys
   (Seq_Back0_TH1 n)
     = (Back0 -> <TH0> |[CH0]| <VAR n> |[CH1]| <TH1>) -- (CH0 Un CH1)"
      
 "Seq_to_Sys
   (Seq_TH0_Back1 n)
     = (<TH0> |[CH0]| <VAR n> |[CH1]| Back1 -> <TH1>) -- (CH0 Un CH1)"

 "Seq_to_Sys
   (Seq_EAT0_TH1 n)
     = IF EVEN n
       THEN (<EAT0 n> |[CH0]| <VAR n> |[CH1]| <TH1>) -- (CH0 Un CH1)
       ELSE undef -> DIV"

 "Seq_to_Sys
   (Seq_TH0_EAT1 n)
     = IF ODD n 
       THEN (<TH0> |[CH0]| <VAR n> |[CH1]| <EAT1 n>) -- (CH0 Un CH1)
       ELSE undef -> DIV"

 "Seq_to_Sys
   (Seq_WR0_TH1 n)
     = IF EVEN n
       THEN (WR0 (n div 2) -> <TH0> |[CH0]| <VAR n> |[CH1]| <TH1>)
             -- (CH0 Un CH1)
       ELSE undef -> DIV"

 "Seq_to_Sys
   (Seq_TH0_WR1 n)
     = IF ODD n
       THEN (<TH0> |[CH0]| <VAR n> |[CH1]| WR1 (3 * n + 1) -> <TH1>)
             -- (CH0 Un CH1)
       ELSE undef -> DIV"

 "Seq_to_Sys
   (Seq_EAT0_Back1 n)
     = IF EVEN n
       THEN (<EAT0 n> |[CH0]| <VAR n> |[CH1]| Back1 -> <TH1>)
             -- (CH0 Un CH1)
       ELSE undef -> DIV"

 "Seq_to_Sys
   (Seq_Back0_EAT1 n)
     = IF ODD n
       THEN (Back0 -> <TH0> |[CH0]| <VAR n> |[CH1]| <EAT1 n>)
             -- (CH0 Un CH1)
       ELSE undef -> DIV"

 "Seq_to_Sys
   (Seq_WR0_Back1 n)
     = IF EVEN n
       THEN (WR0 (n div 2) -> <TH0> |[CH0]| <VAR n> |[CH1]| Back1 -> <TH1>)
             -- (CH0 Un CH1)
       ELSE undef -> DIV"

 "Seq_to_Sys
   (Seq_Back0_WR1 n)
     = IF ODD n
       THEN (Back0 -> <TH0> |[CH0]| <VAR n> |[CH1]| WR1 (3 * n + 1) -> <TH1>)
             -- (CH0 Un CH1)
       ELSE undef -> DIV"

end
