           (*-------------------------------------------*
            |  The Dining Mathematicians in Csp-Prover  |
            |                June 2004                  |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory DM15_Spc_Seq = DM14_Spc_def:

(*****************************************************************

         1. proves lemma for Spc <=F Seq
         2.
         3. 
         4. 

 *****************************************************************)

(*** TH0_TH1_SUB ***)

lemma TH0_TH1_SUB[simp]:
          "LET SeqDef IN     ! x:range NUM .. <Seq_TH0_TH1 (inv NUM x)> 
                         |~| ! x:range NUM .. <Seq_Back0_TH1 (inv NUM x)> 
                         |~| ! x:range NUM .. <Seq_TH0_Back1 (inv NUM x)> 
                         |~| ! x:(NUM ` EVENs) .. <Seq_Eat0_TH1 (inv NUM x)> 
                         |~| ! x:(NUM ` ODDs) .. <Seq_TH0_Eat1 (inv NUM x)> 
                         |~| ! x:(NUM ` EVENs) .. <Seq_WR0_TH1 (inv NUM x)> 
                         |~| ! x:(NUM ` EVENs) .. <Seq_WR0_Back1 (inv NUM x)> 
                         |~| ! x:(NUM ` ODDs) .. <Seq_TH0_WR1 (inv NUM x)> 
                         |~| ! x:(NUM ` ODDs) .. <Seq_Back0_WR1 (inv NUM x)>
            <=F 
           LET SeqDef IN <Seq_TH0_TH1 n>"
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_bind_left)
apply (rule_tac x="NUM n" in exI)
apply (simp)
done

(*** Back0_TH1_SUB ***)

lemma Back0_TH1_SUB[simp]:
          "LET SeqDef IN     ! x:range NUM .. <Seq_TH0_TH1 (inv NUM x)> 
                         |~| ! x:range NUM .. <Seq_Back0_TH1 (inv NUM x)> 
                         |~| ! x:range NUM .. <Seq_TH0_Back1 (inv NUM x)> 
                         |~| ! x:(NUM ` EVENs) .. <Seq_Eat0_TH1 (inv NUM x)> 
                         |~| ! x:(NUM ` ODDs) .. <Seq_TH0_Eat1 (inv NUM x)> 
                         |~| ! x:(NUM ` EVENs) .. <Seq_WR0_TH1 (inv NUM x)> 
                         |~| ! x:(NUM ` EVENs) .. <Seq_WR0_Back1 (inv NUM x)> 
                         |~| ! x:(NUM ` ODDs) .. <Seq_TH0_WR1 (inv NUM x)> 
                         |~| ! x:(NUM ` ODDs) .. <Seq_Back0_WR1 (inv NUM x)>
            <=F 
           LET SeqDef IN <Seq_Back0_TH1 n>"
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left2)
apply (rule csp_Int_bind_left)
apply (rule_tac x="NUM n" in exI)
apply (simp)
done

(*** TH0_Back1_SUB ***)

lemma TH0_Back1_SUB[simp]:
          "LET SeqDef IN     ! x:range NUM .. <Seq_TH0_TH1 (inv NUM x)> 
                         |~| ! x:range NUM .. <Seq_Back0_TH1 (inv NUM x)> 
                         |~| ! x:range NUM .. <Seq_TH0_Back1 (inv NUM x)> 
                         |~| ! x:(NUM ` EVENs) .. <Seq_Eat0_TH1 (inv NUM x)> 
                         |~| ! x:(NUM ` ODDs) .. <Seq_TH0_Eat1 (inv NUM x)> 
                         |~| ! x:(NUM ` EVENs) .. <Seq_WR0_TH1 (inv NUM x)> 
                         |~| ! x:(NUM ` EVENs) .. <Seq_WR0_Back1 (inv NUM x)> 
                         |~| ! x:(NUM ` ODDs) .. <Seq_TH0_WR1 (inv NUM x)> 
                         |~| ! x:(NUM ` ODDs) .. <Seq_Back0_WR1 (inv NUM x)>
            <=F 
           LET SeqDef IN <Seq_TH0_Back1 n>"
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left2)
apply (rule csp_Int_bind_left)
apply (rule_tac x="NUM n" in exI)
apply (simp)
done

(*** Eat0_TH1_SUB ***)

lemma Eat0_TH1_SUB[simp]:
          "EVEN n ==>
           LET SeqDef IN     ! x:range NUM .. <Seq_TH0_TH1 (inv NUM x)> 
                         |~| ! x:range NUM .. <Seq_Back0_TH1 (inv NUM x)> 
                         |~| ! x:range NUM .. <Seq_TH0_Back1 (inv NUM x)> 
                         |~| ! x:(NUM ` EVENs) .. <Seq_Eat0_TH1 (inv NUM x)> 
                         |~| ! x:(NUM ` ODDs) .. <Seq_TH0_Eat1 (inv NUM x)> 
                         |~| ! x:(NUM ` EVENs) .. <Seq_WR0_TH1 (inv NUM x)> 
                         |~| ! x:(NUM ` EVENs) .. <Seq_WR0_Back1 (inv NUM x)> 
                         |~| ! x:(NUM ` ODDs) .. <Seq_TH0_WR1 (inv NUM x)> 
                         |~| ! x:(NUM ` ODDs) .. <Seq_Back0_WR1 (inv NUM x)>
            <=F 
           LET SeqDef IN <Seq_Eat0_TH1 n>"
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left2)
apply (rule csp_Int_bind_left)
apply (rule_tac x="NUM n" in exI)
apply (simp)
done

(*** TH0_Eat1_SUB ***)

lemma TH0_Eat1_SUB[simp]:
          "ODD n ==>
           LET SeqDef IN     ! x:range NUM .. <Seq_TH0_TH1 (inv NUM x)> 
                         |~| ! x:range NUM .. <Seq_Back0_TH1 (inv NUM x)> 
                         |~| ! x:range NUM .. <Seq_TH0_Back1 (inv NUM x)> 
                         |~| ! x:(NUM ` EVENs) .. <Seq_Eat0_TH1 (inv NUM x)> 
                         |~| ! x:(NUM ` ODDs) .. <Seq_TH0_Eat1 (inv NUM x)> 
                         |~| ! x:(NUM ` EVENs) .. <Seq_WR0_TH1 (inv NUM x)> 
                         |~| ! x:(NUM ` EVENs) .. <Seq_WR0_Back1 (inv NUM x)> 
                         |~| ! x:(NUM ` ODDs) .. <Seq_TH0_WR1 (inv NUM x)> 
                         |~| ! x:(NUM ` ODDs) .. <Seq_Back0_WR1 (inv NUM x)>
            <=F 
           LET SeqDef IN <Seq_TH0_Eat1 n>"
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left2)
apply (rule csp_Int_bind_left)
apply (rule_tac x="NUM n" in exI)
apply (simp)
done

(*** TH0_Eat1_SUB ***)

lemma WR0_TH1_SUB[simp]:
          "EVEN n ==>
           LET SeqDef IN     ! x:range NUM .. <Seq_TH0_TH1 (inv NUM x)> 
                         |~| ! x:range NUM .. <Seq_Back0_TH1 (inv NUM x)> 
                         |~| ! x:range NUM .. <Seq_TH0_Back1 (inv NUM x)> 
                         |~| ! x:(NUM ` EVENs) .. <Seq_Eat0_TH1 (inv NUM x)> 
                         |~| ! x:(NUM ` ODDs) .. <Seq_TH0_Eat1 (inv NUM x)> 
                         |~| ! x:(NUM ` EVENs) .. <Seq_WR0_TH1 (inv NUM x)> 
                         |~| ! x:(NUM ` EVENs) .. <Seq_WR0_Back1 (inv NUM x)> 
                         |~| ! x:(NUM ` ODDs) .. <Seq_TH0_WR1 (inv NUM x)> 
                         |~| ! x:(NUM ` ODDs) .. <Seq_Back0_WR1 (inv NUM x)>
            <=F 
           LET SeqDef IN <Seq_WR0_TH1 n>"
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left2)
apply (rule csp_Int_bind_left)
apply (rule_tac x="NUM n" in exI)
apply (simp)
done

(*** WR0_Back1_SUB ***)

lemma WR0_Back1_SUB[simp]:
          "EVEN n ==>
           LET SeqDef IN     ! x:range NUM .. <Seq_TH0_TH1 (inv NUM x)> 
                         |~| ! x:range NUM .. <Seq_Back0_TH1 (inv NUM x)> 
                         |~| ! x:range NUM .. <Seq_TH0_Back1 (inv NUM x)> 
                         |~| ! x:(NUM ` EVENs) .. <Seq_Eat0_TH1 (inv NUM x)> 
                         |~| ! x:(NUM ` ODDs) .. <Seq_TH0_Eat1 (inv NUM x)> 
                         |~| ! x:(NUM ` EVENs) .. <Seq_WR0_TH1 (inv NUM x)> 
                         |~| ! x:(NUM ` EVENs) .. <Seq_WR0_Back1 (inv NUM x)> 
                         |~| ! x:(NUM ` ODDs) .. <Seq_TH0_WR1 (inv NUM x)> 
                         |~| ! x:(NUM ` ODDs) .. <Seq_Back0_WR1 (inv NUM x)>
            <=F 
           LET SeqDef IN <Seq_WR0_Back1 n>"
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left2)
apply (rule csp_Int_bind_left)
apply (rule_tac x="NUM n" in exI)
apply (simp)
done

(*** TH0_WR1_SUB ***)

lemma TH0_WR1_SUB[simp]:
          "ODD n ==>
           LET SeqDef IN     ! x:range NUM .. <Seq_TH0_TH1 (inv NUM x)> 
                         |~| ! x:range NUM .. <Seq_Back0_TH1 (inv NUM x)> 
                         |~| ! x:range NUM .. <Seq_TH0_Back1 (inv NUM x)> 
                         |~| ! x:(NUM ` EVENs) .. <Seq_Eat0_TH1 (inv NUM x)> 
                         |~| ! x:(NUM ` ODDs) .. <Seq_TH0_Eat1 (inv NUM x)> 
                         |~| ! x:(NUM ` EVENs) .. <Seq_WR0_TH1 (inv NUM x)> 
                         |~| ! x:(NUM ` EVENs) .. <Seq_WR0_Back1 (inv NUM x)> 
                         |~| ! x:(NUM ` ODDs) .. <Seq_TH0_WR1 (inv NUM x)> 
                         |~| ! x:(NUM ` ODDs) .. <Seq_Back0_WR1 (inv NUM x)>
            <=F 
           LET SeqDef IN <Seq_TH0_WR1 n>"
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_choice_left2)
apply (rule csp_Int_bind_left)
apply (rule_tac x="NUM n" in exI)
apply (simp)
done

(*** Back0_WR1_SUB ***)

lemma Back0_WR1_SUB[simp]:
          "ODD n ==>
           LET SeqDef IN     ! x:range NUM .. <Seq_TH0_TH1 (inv NUM x)> 
                         |~| ! x:range NUM .. <Seq_Back0_TH1 (inv NUM x)> 
                         |~| ! x:range NUM .. <Seq_TH0_Back1 (inv NUM x)> 
                         |~| ! x:(NUM ` EVENs) .. <Seq_Eat0_TH1 (inv NUM x)> 
                         |~| ! x:(NUM ` ODDs) .. <Seq_TH0_Eat1 (inv NUM x)> 
                         |~| ! x:(NUM ` EVENs) .. <Seq_WR0_TH1 (inv NUM x)> 
                         |~| ! x:(NUM ` EVENs) .. <Seq_WR0_Back1 (inv NUM x)> 
                         |~| ! x:(NUM ` ODDs) .. <Seq_TH0_WR1 (inv NUM x)> 
                         |~| ! x:(NUM ` ODDs) .. <Seq_Back0_WR1 (inv NUM x)>
            <=F 
           LET SeqDef IN <Seq_Back0_WR1 n>"
apply (rule csp_Int_choice_left2)
apply (rule csp_Int_bind_left)
apply (rule_tac x="NUM n" in exI)
apply (simp)
done

(*** EAT0_TH1_SUB ***)

lemma EAT0_TH1_SUB[simp]:
          "EVEN n ==>
           LET SeqDef IN     ! x:(NUM ` EVENs) .. <Seq_EAT0_TH1 (inv NUM x)> 
                         |~| ! x:(NUM ` EVENs) .. <Seq_EAT0_Back1 (inv NUM x)> 
            <=F
           LET SeqDef IN <Seq_EAT0_TH1 n>"
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_bind_left)
apply (rule_tac x="NUM n" in exI)
apply (simp)
done

(*** EAT0_Back1_SUB ***)

lemma EAT0_Back1_SUB[simp]:
          "EVEN n ==>
           LET SeqDef IN     ! x:(NUM ` EVENs) .. <Seq_EAT0_TH1 (inv NUM x)> 
                         |~| ! x:(NUM ` EVENs) .. <Seq_EAT0_Back1 (inv NUM x)> 
            <=F
           LET SeqDef IN <Seq_EAT0_Back1 n>"
apply (rule csp_Int_choice_left2)
apply (rule csp_Int_bind_left)
apply (rule_tac x="NUM n" in exI)
apply (simp)
done

(*** TH0_EAT1_SUB ***)

lemma TH0_EAT1_SUB[simp]:
          "ODD n ==>
           LET SeqDef IN     ! x:(NUM ` ODDs) .. <Seq_TH0_EAT1 (inv NUM x)> 
                         |~| ! x:(NUM ` ODDs) .. <Seq_Back0_EAT1 (inv NUM x)>
            <=F
           LET SeqDef IN <Seq_TH0_EAT1 n>"
apply (rule csp_Int_choice_left1)
apply (rule csp_Int_bind_left)
apply (rule_tac x="NUM n" in exI)
apply (simp)
done

(*** Back0_EAT1_SUB ***)

lemma Back0_EAT1_SUB[simp]:
          "ODD n ==>
           LET SeqDef IN     ! x:(NUM ` ODDs) .. <Seq_TH0_EAT1 (inv NUM x)> 
                         |~| ! x:(NUM ` ODDs) .. <Seq_Back0_EAT1 (inv NUM x)>
            <=F
           LET SeqDef IN <Seq_Back0_EAT1 n>"
apply (rule csp_Int_choice_left2)
apply (rule csp_Int_bind_left)
apply (rule_tac x="NUM n" in exI)
apply (simp)
done

end
