           (*-------------------------------------------*
            |  The Dining Mathematicians in Csp-Prover  |
            |                June 2004                  |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory DM17_Spc_Seq = DM16_Spc_Seq:

(*****************************************************************

         1. proves lemma for Spc <=F Seq
         2. proves Spc <=F Seq and Spc <=F Sys
         3. 
         4. 

 *****************************************************************)


(*** TH0_TH1 ***)

lemma TH0_TH1[simp]:
  "LET SeqDef IN (Rewrite (SpcDef TH0_TH1) By Spc_to_Seq) <=F 
   LET SeqDef IN Spc_to_Seq TH0_TH1"
apply (simp)
apply (rule)+

 (* SEQ_TH0_TH1 *)
apply (tactic {* csp_unwind_right_tac 1 *})
apply (erule exE)
apply (case_tac "EVEN x")
apply (tactic {* csp_simp_right_tac 1 *})
apply (tactic {* csp_simp_right_tac 1 *})

 (* SEQ_Back0_TH1 *)
apply (rule)
apply (tactic {* csp_unwind_right_tac 1 *})
apply (erule exE)
apply (case_tac "EVEN x")
apply (tactic {* csp_simp_right_tac 1 *})
apply (tactic {* csp_simp_right_tac 1 *})

 (* Seq_TH0_Back1 *)
apply (rule)
apply (tactic {* csp_unwind_right_tac 1 *})
apply (erule exE)
apply (case_tac "EVEN x")
apply (tactic {* csp_simp_right_tac 1 *})
apply (tactic {* csp_simp_right_tac 1 *})

 (* Seq_Eat0_TH1 *)
apply (rule)
apply (tactic {* csp_unwind_right_tac 1 *})
apply (erule exE)
apply (tactic {* csp_simp_right_tac 1 *})

 (* Seq_TH0_Eat1 *)
apply (rule)
apply (tactic {* csp_unwind_right_tac 1 *})
apply (erule exE)
apply (tactic {* csp_simp_right_tac 1 *})

 (* Seq_WR0_TH1 *)
apply (rule)
apply (tactic {* csp_unwind_right_tac 1 *})
apply (erule exE)
apply (case_tac "ODD (x div 2)")
apply (tactic {* csp_simp_right_tac 1 *})
apply (tactic {* csp_simp_right_tac 1 *})

 (* Seq_WR0_Back1 *)
apply (rule)
apply (tactic {* csp_unwind_right_tac 1 *})
apply (erule exE)
apply (case_tac "ODD (x div 2)")
apply (tactic {* csp_simp_right_tac 1 *})
apply (tactic {* csp_simp_right_tac 1 *})

 (* Seq_TH0_WR1 *)
apply (rule)
apply (tactic {* csp_unwind_right_tac 1 *})
apply (erule exE)
apply (tactic {* csp_simp_right_tac 1 *})

 (* Seq_Back0_WR1 *)
apply (rule)
apply (tactic {* csp_unwind_right_tac 1 *})
apply (erule exE)
apply (tactic {* csp_simp_right_tac 1 *})
done

(*********************************************************
                  ALL n. Spc <=F Sys n
 *********************************************************)

lemma check_Spc_Seq: "CHECK Spc <=F (Seq n) BY Spc_to_Seq"
apply (rule)
apply (simp_all add: Spc_def Seq_def)
apply (induct_tac C)
apply (simp del: SpcDef.simps Spc_to_Seq.simps)+
done

(*********************************************************
                     Consequently
 *********************************************************)

lemma Spc_ref_Seq: "Spc <=F Seq n"
apply (insert check_Spc_Seq[of n])
apply (simp add: csp_fp_induct)
done

(*********************************************************
                       Finally
 *********************************************************)

lemma Spc_ref_Sys: "Spc <=F Sys n"
apply (rule csp_trans)
apply (rule Spc_ref_Seq)
apply (rule csp_eq_ref)
apply (rule Seq_eq_Sys)
done

end
